SystemOrganization addCategory: #Estanciero!
SystemOrganization addCategory: #'Estanciero-Tests'!

TestCase subclass: #EstancieroTest
	instanceVariableNames: 'formosaZonaSur zonaSur formosaZonaCentro zonaCentro formosaZonaNorte zonaNorte petrolera formosa salta saltaZonaSur saltaZonaCentro saltaZonaNorte bodega tucuman tucumanZonaSur tucumanZonaNorte fabrica cordoba cordobaZonaSur cordobaZonaCentro cordobaZonaNorte jacobo samuel david'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero-Tests'!

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:35'!
setUp 

Tablero instance initialize.
Juego instance initialize.
Tablero instance agregarCasillero: Salida instance.

formosa := Provincia new.

formosaZonaSur := Campo new.
formosa agregarCampo: formosaZonaSur.
formosaZonaSur precioDeCompra: 1000.
formosaZonaSur valorDeRentaFijo: 500.
formosaZonaSur costoDeEstancia: 500.
Tablero instance agregarCasillero: formosaZonaSur.

formosaZonaCentro := Campo new.
formosa agregarCampo: formosaZonaCentro.
formosaZonaCentro precioDeCompra: 1000.
formosaZonaCentro valorDeRentaFijo: 500.
formosaZonaCentro costoDeEstancia: 250.
Tablero instance agregarCasillero: formosaZonaCentro.

formosaZonaNorte := Campo new.
formosa agregarCampo: formosaZonaNorte.
formosaZonaNorte precioDeCompra: 1200.
formosaZonaNorte valorDeRentaFijo: 600.
formosaZonaNorte costoDeEstancia: 300.
Tablero instance agregarCasillero: formosaZonaNorte.

Tablero instance agregarCasillero: PremioGanadero instance.

petrolera := Empresa new.
petrolera precioDeCompra: 380.
Tablero instance agregarCasillero: petrolera.

salta := Provincia new.

saltaZonaSur := Campo new.
salta agregarCampo: saltaZonaSur.
saltaZonaSur precioDeCompra: 2600.
saltaZonaSur valorDeRentaFijo: 800.
saltaZonaSur costoDeEstancia: 300.
Tablero instance agregarCasillero: saltaZonaSur.

saltaZonaCentro := Campo new.
salta agregarCampo: saltaZonaCentro.
saltaZonaCentro precioDeCompra: 2600.
saltaZonaCentro  valorDeRentaFijo: 850.
saltaZonaCentro  costoDeEstancia: 300.
Tablero instance agregarCasillero: saltaZonaCentro.

saltaZonaNorte := Campo new.
salta agregarCampo: saltaZonaNorte.
saltaZonaNorte precioDeCompra: 3000.
saltaZonaNorte valorDeRentaFijo: 900.
saltaZonaNorte costoDeEstancia: 350.
Tablero instance agregarCasillero: saltaZonaNorte.

bodega := Empresa new.
bodega precioDeCompra: 380.
Tablero instance agregarCasillero: bodega.

Tablero instance agregarCasillero: Comisaria instance.

tucuman := Provincia new.

tucumanZonaSur := Campo new.
tucuman agregarCampo: tucumanZonaSur.
tucumanZonaSur precioDeCompra: 5000.
tucumanZonaSur valorDeRentaFijo: 1000.
tucumanZonaSur costoDeEstancia: 400.
Tablero instance agregarCasillero: tucumanZonaSur.

tucumanZonaNorte := Campo new.
tucuman agregarCampo: tucumanZonaNorte.
tucumanZonaNorte precioDeCompra: 5400.
tucumanZonaNorte valorDeRentaFijo: 1200.
tucumanZonaNorte costoDeEstancia: 500.
Tablero instance agregarCasillero: tucumanZonaNorte.

fabrica := Empresa new.
fabrica precioDeCompra: 380.
Tablero instance agregarCasillero: fabrica.

cordoba := Provincia new.

cordobaZonaSur := Campo new.
cordoba agregarCampo: cordobaZonaSur.
cordobaZonaSur precioDeCompra: 6000.
cordobaZonaSur valorDeRentaFijo: 1500.
cordobaZonaSur costoDeEstancia: 800.
Tablero instance agregarCasillero: cordobaZonaSur.

cordobaZonaCentro := Campo new.
cordoba agregarCampo: cordobaZonaCentro.
cordobaZonaCentro precioDeCompra: 6000.
cordobaZonaCentro valorDeRentaFijo: 1500.
cordobaZonaCentro costoDeEstancia: 800.
Tablero instance agregarCasillero: cordobaZonaCentro.

cordobaZonaNorte := Campo new.
cordoba agregarCampo: cordobaZonaNorte.
cordobaZonaNorte precioDeCompra: 6400.
cordobaZonaNorte valorDeRentaFijo: 1500.
cordobaZonaNorte costoDeEstancia: 900.
Tablero instance agregarCasillero: cordobaZonaNorte.

jacobo := Jugador new.
jacobo cobra: 50000.
jacobo agregarPropiedad: tucumanZonaSur.
tucumanZonaSur duenio: jacobo.
jacobo agregarPropiedad: tucumanZonaNorte.
tucumanZonaNorte duenio: jacobo.
jacobo agregarPropiedad: formosaZonaSur.
formosaZonaSur duenio: jacobo.
tucumanZonaNorte sumarEstancia.
Juego instance agregarJugador: jacobo.

samuel := Jugador new.
samuel cobra: 10000.
samuel agregarPropiedad: cordobaZonaSur. 
cordobaZonaSur duenio: samuel.
samuel agregarPropiedad: cordobaZonaCentro. 
cordobaZonaCentro duenio: samuel.
samuel agregarPropiedad: cordobaZonaNorte.
cordobaZonaNorte duenio: samuel.
samuel agregarPropiedad: formosaZonaCentro.
formosaZonaCentro duenio: samuel.
samuel agregarPropiedad: bodega.
bodega duenio: samuel.
samuel agregarPropiedad: petrolera.
petrolera duenio: samuel.
Juego instance agregarJugador: samuel.

david := Jugador new.
Juego instance agregarJugador: david.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:47'!
testCantidadDeEmpresasDeSamuel

self assert: samuel cantidadDeEmpresas equals: 2.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:28'!
testDueniosDeFormosa

|coleccionJugadores|

coleccionJugadores := Set new.
coleccionJugadores add: samuel.
coleccionJugadores add: jacobo.
coleccionJugadores add: Banco instance.
self assert: (formosa duenios) equals: coleccionJugadores.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:27'!
testDueniosDeTucuman

|coleccionJugadores|

coleccionJugadores := Set new.
coleccionJugadores add: jacobo.
self assert: (tucuman duenios) equals: coleccionJugadores.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:13'!
testJacoboCompraLaFabricaYConsultaRentaParaSamuel

|intervalo|

intervalo := Interval from: 60000 to: 360000.

jacobo compra: fabrica.

self assert: (intervalo includes: (fabrica rentaPara: samuel) )equals:  true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:37'!
testJacoboConstruyeEstanciaEnTucumanZonaSur

jacobo construirEstanciaEn: tucumanZonaSur.
self assert: jacobo dinero equals: 49600.
self assert: tucumanZonaSur cantidadDeEstancias  equals: 1.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:20'!
testJacoboGarcaCaeEnFormosaZonaNorteYLaCompra

jacobo usarEstrategia: EstrategiaGarca new.
formosaZonaNorte cayo: jacobo.

self assert:((jacobo propiedades) includes: formosaZonaNorte) equals: true.
self assert: jacobo dinero equals: 48800.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:04'!
testJacoboHipotecaTucumanZonaNorte

jacobo hipoteca: tucumanZonaNorte.

self assert: tucumanZonaNorte duenio equals: Banco instance.
self assert: jacobo dinero equals: 52950.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:46'!
testJacoboImperialistaCaeEnCordobaZonaSurYNoLaCompra

jacobo usarEstrategia: EstrategiaImperialista new.
cordobaZonaSur cayo: jacobo .

self assert:((jacobo propiedades) includes: cordobaZonaSur) equals: false.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:44'!
testJacoboIntentaConstruirEstanciaEnFormosaZonaCentro

jacobo construirEstanciaEn: formosaZonaCentro.
formosaZonaCentro cantidadDeEstancias.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:46'!
testJacoboIntentaConstruirEstanciaEnTucumanZonaNorte

jacobo construirEstanciaEn: tucumanZonaNorte.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:16'!
testJacoboPaga10000ASamuel

jacobo pagaA: samuel elMontoDe: 10000.

self assert: samuel dinero  equals: 20000.
self assert: jacobo dinero  equals: 40000.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:37'!
testJacoboPasaPorFormosaZonaCentro

formosaZonaCentro paso: jacobo.

self assert: samuel dinero = 10000 equals: true.
self assert: jacobo dinero = 50000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:10'!
testJacoboTiraLosDadosYSacaEntre2Y12

|intervalo|

intervalo := Interval from: 2 to: 12.
jacobo tirarDados.

self assert: (intervalo includes: (jacobo valor)) equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:53'!
testRentaDeTucumanZonaNorteParaSamuel

self assert: (tucumanZonaNorte rentaPara: samuel ) equals: 2400.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:52'!
testRentaDeTucumanZonaSurParaSamuel

self assert: (tucumanZonaSur rentaPara: samuel ) equals: 1000.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:15'!
testRestaDeBodegaParaJacobo

|intervalo|

intervalo := Interval from: 120000 to: 720000.

self assert: (intervalo includes: (bodega rentaPara: jacobo) )equals:  true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:08'!
testSamuelCaeEnFormosaZonaCentro

formosaZonaCentro cayo: samuel.

self assert: samuel dinero = 10000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:41'!
testSamuelCaeEnLaSalida

Salida instance cayo: samuel.

self assert: samuel dinero = 10000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:52'!
testSamuelCaeEnPremioGanadero

PremioGanadero instance cayo: samuel.

self assert: samuel dinero = 12500 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:11'!
testSamuelCaeEnSaltaZonaSurYLaCompra

saltaZonaSur cayo: samuel.

self assert: ((samuel propiedades) includes: saltaZonaSur)  equals: true.
self assert: samuel dinero = 7400 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:13'!
testSamuelCaeEnTucumanZonaSurYLePagaAJacobo

tucumanZonaSur cayo: samuel.

self assert: jacobo dinero = 51000 equals: true.
self assert: samuel dinero = 9000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:58'!
testSamuelCaePorPrision

| propiedades |
Prision instance cayo: samuel.

propiedades := Set new.
propiedades add: cordobaZonaSur .
propiedades add: cordobaZonaCentro.
propiedades add: cordobaZonaNorte.
propiedades add: formosaZonaCentro.
propiedades add: bodega.
propiedades add: petrolera.

self assert: samuel dinero equals: 10000.
self assert: samuel propiedades  equals: propiedades.
self assert: samuel estado class equals: JugadorLibre.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:22'!
testSamuelGarcaCaeEnSaltaZonaSurYNoLaCompra

samuel usarEstrategia: EstrategiaGarca new.
saltaZonaSur cayo: samuel .

self assert:((samuel propiedades) includes: saltaZonaSur) equals: false.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:03'!
testSamuelHipotecaCordobaZonaNorte

samuel hipoteca: cordobaZonaNorte.

self assert: cordobaZonaNorte duenio equals: Banco instance.
self assert: samuel dinero equals: 13200.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:05'!
testSamuelHipotecabodega

samuel hipoteca: bodega.

self assert: bodega duenio equals: Banco instance.
self assert: samuel dinero equals: 10190.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:39'!
testSamuelImperialistaCaeEnFormosaZonaNorteYLaCompra

samuel usarEstrategia: EstrategiaImperialista new.
formosaZonaNorte cayo: samuel .

self assert:((samuel propiedades) includes: formosaZonaNorte) equals: true.
self assert: samuel dinero equals: 8800.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:44'!
testSamuelImperialistaCaeEnSaltaZonaSurYLaCompra

samuel usarEstrategia: EstrategiaImperialista new.
saltaZonaSur cayo: samuel .

self assert:((samuel propiedades) includes: saltaZonaSur) equals: true.
self assert: samuel dinero equals: 7400.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:36'!
testSamuelJuegaYCambiaDeLugar

samuel casilleroDondeEsta: (PremioGanadero instance).
Juego instance queJuegue: samuel.

self  assert: (samuel casilleroDondeEsta) = (PremioGanadero instance) equals: false.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:14'!
testSamuelLePagaAJacobo50000YCaeEnBancarrota

samuel pagaA: jacobo elMontoDe: 50000.

self assert: jacobo dinero equals: 50000.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:34'!
testSamuelPaga12000AJacobo

samuel pagaA: jacobo elMontoDe: 12000.

self assert: samuel dinero = 10000 equals: false.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:40'!
testSamuelPasaPorElPremioGanadero

PremioGanadero instance paso: samuel.

self assert: samuel dinero = 10000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:36'!
testSamuelPasaPorLaSalida

Salida instance paso: samuel.

self assert: samuel dinero = 15000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:58'!
testSamuelPasaPorPrision

| propiedades |
Prision instance paso: samuel.

propiedades := Set new.
propiedades add: cordobaZonaSur .
propiedades add: cordobaZonaCentro.
propiedades add: cordobaZonaNorte.
propiedades add: formosaZonaCentro.
propiedades add: bodega.
propiedades add: petrolera.

self assert: samuel dinero equals: 10000.
self assert: samuel propiedades  equals: propiedades.
self assert: samuel estado class equals: JugadorLibre.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 03:08'!
testSamuelQuedaEnBancarrotaYSigueDavid

Juego instance queJuegueElQueSigue.
samuel perdiste.
Juego instance queJuegueElQueSigue.

self assert: (david casilleroDondeEsta =  Salida instance) equals: false.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:13'!
testSamuelSeMueveYPasaPorLaSalida

| recorrido |

recorrido := (Tablero instance) casillerosDesde: cordobaZonaNorte  hasta: 2.
samuel movetePor: recorrido.

self assert: samuel dinero equals: 14500.
self assert: samuel casilleroDondeEsta equals: formosaZonaSur.
! !

Object subclass: #Banco
	instanceVariableNames: 'propiedades'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Banco class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:11'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:02'!
agregarPropiedad: unaPropiedad

propiedades add: unaPropiedad.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/6/2012 17:48'!
cayo: unJugador en: unaPropiedad

(unJugador puedeComprar: unaPropiedad) ifTrue: [unJugador compra: unaPropiedad].
! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 17:50'!
cobra: unMonto
! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:07'!
initialize 
propiedades := Set new.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/17/2012 15:04'!
paga: unMonto! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 17:48'!
pagaA: unJugador elMontoDe: unMonto 

unJugador cobra: unMonto.! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/17/2012 14:06'!
quitarPropiedad: unaPropiedad 

propiedades remove:  unaPropiedad.! !

Object subclass: #Casillero
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Casillero methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:30'!
cayo: unJugador! !

!Casillero methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 02:54'!
paso: unJugador 
! !

!Casillero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:02'!
sosEmpresa 
^false.! !

Casillero subclass: #Comisaria
	instanceVariableNames: ''
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Comisaria class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:52'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

Casillero subclass: #PremioGanadero
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!PremioGanadero class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:40'!
instance
Instance := self new.
^Instance.! !

!PremioGanadero methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:31'!
cayo: unJugador 
unJugador cobra: 2500.! !

Casillero subclass: #Prision
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Prision class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:12'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

Casillero subclass: #Propiedad
	instanceVariableNames: 'estado duenio precioDeCompra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Propiedad subclass: #Campo
	instanceVariableNames: 'provincia valorRentaFijo costoDeEstancia cantidadDeEstancias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 22:57'!
agregarEstancia
provincia agregarEstanciaEn: self.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:18'!
cantidadDeEstancias
^cantidadDeEstancias.
! !

!Campo methodsFor: 'as yet unclassified' stamp: 'palbo 10/13/2012 12:00'!
cantidadDeEstancias: cantidad
cantidadDeEstancias:= cantidad
! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:33'!
costoDeEstancia 
^costoDeEstancia.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:35'!
costoDeEstancia: unMonto 
costoDeEstancia := unMonto.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 14:33'!
dueniosDePropiedadesAmigas
^(self provincia) duenios! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:25'!
hayAlgunDuenioDistintoDe: unJugador
^(self provincia) duenios anySatisfy: [ :unElem | unElem ~= unJugador & unElem ~= Banco instance ]! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:25'!
initialize 
super initialize.
cantidadDeEstancias := 0! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:42'!
leSirveParaElImperioDe: unJugador
^((super leSirveParaElImperioDe: unJugador)
|
((self dueniosDePropiedadesAmigas ) anySatisfy: [ :unElem | unElem = unJugador]))! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:37'!
perteneceAProvincia: unaProvincia
provincia := unaProvincia.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'palbo 10/13/2012 12:04'!
precioDeHipoteca
^(precioDeCompra /2)+(cantidadDeEstancias * costoDeEstancia / 2)! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:38'!
provincia
^provincia.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 01:04'!
rentaPara: jugadorQueCayo

^((2 raisedTo: cantidadDeEstancias) * valorRentaFijo).! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:46'!
sumarEstancia 
cantidadDeEstancias := cantidadDeEstancias +1! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:40'!
valorDeRentaFijo 
^valorRentaFijo ! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:40'!
valorDeRentaFijo: unMonto 
valorRentaFijo := unMonto.! !

Propiedad subclass: #Empresa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:49'!
dueniosDePropiedadesAmigas
^(Tablero instance dueniosEmpresas)
! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'palbo 10/13/2012 12:03'!
precioDeHipoteca
^(precioDeCompra /2)! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 01:05'!
rentaPara: jugadorQueCayo

|empresasAcumuladas valorDados|

empresasAcumuladas := duenio cantidadDeEmpresas.
valorDados := jugadorQueCayo tirarDados.

^(valorDados * 30000 * empresasAcumuladas).! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 17:32'!
sosEmpresa
^true! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/6/2012 17:23'!
cayo: unJugador 

(duenio = unJugador) ifFalse: [duenio cayo: unJugador en: self].! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:24'!
duenio
^duenio.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:06'!
duenio: elDuenio

duenio := elDuenio.
! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 17:11'!
hayAlgunDuenioDistintoDe: unJugador
^(self dueniosDePropiedadesAmigas ) anySatisfy: [ :unElem | unElem ~= unJugador & unElem ~= Banco instance]! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:30'!
hipotecate

duenio cobra: (self precioDeHipoteca).
duenio quitarPropiedad: self.
duenio := Banco instance.
estado := PropiedadHipotecada new.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:13'!
initialize 
estado := PropiedadNoHipotecada new.
duenio := Banco instance.
Banco instance agregarPropiedad: self.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:51'!
leSirveParaElImperioDe: unJugador 
^((self dueniosDePropiedadesAmigas ) allSatisfy: [ :unElem | (unElem = Banco instance | unElem = unJugador) ])! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:31'!
levatarHipoteca 

estado := PropiedadNoHipotecada new.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 00:44'!
precioDeCompra
^precioDeCompra.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 00:43'!
precioDeCompra: unPrecio
precioDeCompra := unPrecio.! !

!Propiedad methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:05'!
sosCompradaPor: unJugador

estado elJugador: unJugador pagaPor: self.
duenio quitarPropiedad: self.
self duenio: unJugador.
unJugador agregarPropiedad: self.! !

Casillero subclass: #Salida
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Salida class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:51'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

!Salida methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 02:54'!
paso: unJugador 
unJugador cobra: 5000.! !

Object subclass: #Dados
	instanceVariableNames: 'doble valor numeros'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Dados methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:03'!
initialize 

|dado1 dado2|

dado1 := (Interval from: 1 to: 6)atRandom.
dado2 := (Interval from: 1 to: 6)atRandom.

numeros := Set new.
numeros add: dado2.
numeros add: dado1.

(dado1 = dado2) ifFalse: [doble := false] ifTrue: [doble := true].

valor := dado1 + dado2.! !

!Dados methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:03'!
numeros 
^numeros! !

!Dados methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:26'!
sosDoble

^doble.! !

!Dados methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:59'!
valor
^valor.! !

Object subclass: #EstrategiaGarca
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EstrategiaGarca methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 13:02'!
compraria: unaPropiedad siendoElDuenio: unJugador 

^unaPropiedad hayAlgunDuenioDistintoDe: unJugador

! !

Object subclass: #EstrategiaImperialista
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EstrategiaImperialista methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 17:08'!
compraria: unaPropiedad siendoElDuenio: unJugador
^unaPropiedad leSirveParaElImperioDe: unJugador
! !

Object subclass: #EstrategiaStandard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EstrategiaStandard methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 11:59'!
compraria: unaPropiedad siendoElDuenio: unJugador
^true.! !

Object subclass: #Juego
	instanceVariableNames: 'jugadores tablero'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Juego class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:38'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:45'!
agregarJugador: unJugador 

jugadores add: unJugador.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:46'!
initialize 
jugadores := OrderedCollection new.
tablero := Tablero instance.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:45'!
jugadores 
^jugadores.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:08'!
queJuegue: unJugador 

|casillerosAMoverse|

unJugador tirarDados.

casillerosAMoverse := tablero casillerosDesde: (unJugador casilleroDondeEsta) hasta: (unJugador valor) .

(unJugador sacoDoble) ifFalse: [unJugador pasaUnTurno.] 
ifTrue: [unJugador pasaUnTurnoConDoble.].

(unJugador puedeMoverse) ifFalse: [self queJuegueElQueSigue] 
ifTrue: [unJugador movetePor: casillerosAMoverse].

^(unJugador numeros).! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 03:04'!
queJuegueElQueSigue
| elQueSigue |
elQueSigue := self jugadores add: self jugadores removeFirst.
^(self queJuegue: elQueSigue).! !

!Juego methodsFor: 'as yet unclassified' stamp: 'palbo 10/13/2012 12:21'!
sacaA: unJugador
jugadores remove: unJugador! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:58'!
tablero
^tablero.! !

Object subclass: #Jugador
	instanceVariableNames: 'dinero propiedades casillero estrategia numero estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:25'!
agregarPropiedad: unaPropiedad 

propiedades add: unaPropiedad.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/16/2012 21:13'!
cantidadDeEmpresas

|cantEmpresas|

cantEmpresas := propiedades select: [:propiedad | propiedad sosEmpresa].

^(cantEmpresas size).! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:41'!
casilleroDondeEsta
^casillero.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:41'!
casilleroDondeEsta: unCasillero

casillero := unCasillero.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 01:06'!
cayo: unJugador en: unaPropiedad 

|monto|

monto := (unaPropiedad rentaPara: unJugador).

unJugador pagaA: self elMontoDe: monto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:31'!
cobra: unMonto
dinero := dinero + unMonto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/25/2012 00:52'!
compra: unaPropiedad 

unaPropiedad sosCompradaPor: self.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:41'!
construirEstanciaEn: unCampo 

unCampo agregarEstancia.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 20:46'!
dinero
^dinero.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 20:51'!
dinero: monto
dinero := monto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:17'!
estado

^estado.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:10'!
estasLibre 

estado := JugadorLibre new.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:11'!
estasPreso 

casillero := Prision instance.
estado := JugadorPreso new.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'palbo 10/6/2012 17:51'!
estrategia
^estrategia.
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:00'!
hipoteca: unaPropiedad 
unaPropiedad hipotecate.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:18'!
hipotecaParaPagarA: unJugador elMontoDe: unMonto

(propiedades size = 0) ifTrue: [self perdiste] 
ifFalse:[self hipoteca: (propiedades asOrderedCollection last).
(unMonto > dinero) ifTrue: [self hipotecaParaPagarA: unJugador elMontoDe: unMonto] 
ifFalse:[self pagaA: unJugador elMontoDe: unMonto]].! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:09'!
initialize 
propiedades := Set new.
estado := JugadorLibre new.
dinero := 0.
estrategia := EstrategiaStandard new.
casillero := Salida instance.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:21'!
movetePor: unosCasilleros

unosCasilleros do: [:casill | casill paso: self].

(unosCasilleros last) cayo: self.
self casilleroDondeEsta:( unosCasilleros last). 
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:07'!
numeros

^(numero numeros )! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 01:30'!
paga: unMonto
dinero := dinero - unMonto.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/14/2012 21:03'!
pagaA: unJugador elMontoDe: unMonto 

(unMonto > dinero) ifTrue: [self hipotecaParaPagarA: unJugador elMontoDe: unMonto] 
ifFalse: [self paga: unMonto.
unJugador cobra: unMonto.]
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:45'!
pasaUnTurno 

estado pasoUnTurno: self.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:46'!
pasaUnTurnoConDoble 

estado pasoUnTurnoConDoble: self.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:13'!
perdiste

self error: 'Caste en Bancarrota. Perdiste!!'.
Juego instance sacaA: self.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/11/2012 01:24'!
propiedades
^propiedades.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'palbo 10/13/2012 11:46'!
pruebapagaA: unJugador elMontoDe: unMonto 

(unMonto > dinero) ifTrue: [self hipotecaParaPagarA: unJugador elMontoDe: unMonto] ifFalse: [self paga: unMonto.
unJugador cobra: unMonto.]
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 12:39'!
puedeComprar: unaPropiedad
^(self estrategia) compraria: unaPropiedad siendoElDuenio: self! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 03:07'!
puedeMoverse 
^(estado sePuedeMover).! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:31'!
quitarPropiedad: unaPropiedad 

propiedades remove:  unaPropiedad.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:03'!
sacoDoble

^(numero sosDoble).
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:04'!
tirarDados

numero := Dados new.
^(numero numeros).! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:16'!
usarEstrategia: unaEstrategia

estrategia := unaEstrategia.! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:05'!
valor 
^(numero valor)! !

Object subclass: #JugadorLibre
	instanceVariableNames: 'primerDoble'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:46'!
initialize 

primerDoble := false.! !

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:08'!
pasoUnTurno: unJugador 
! !

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:09'!
pasoUnTurnoConDoble: unJugador 

(primerDoble) ifFalse: [primerDoble := true] ifTrue: [unJugador estasPreso].

! !

!JugadorLibre methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:21'!
sePuedeMover

^true.! !

Object subclass: #JugadorPreso
	instanceVariableNames: 'cantTurnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 01:49'!
initialize 

cantTurnos := 0.! !

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:07'!
pasoUnTurno: unJugador 

cantTurnos := cantTurnos + 1.

(cantTurnos = 3) ifTrue: [unJugador estasLibre].! !

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:07'!
pasoUnTurnoConDoble: unJugador 

unJugador estasLibre.! !

!JugadorPreso methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/12/2012 02:21'!
sePuedeMover

^false.! !

Object subclass: #PropiedadHipotecada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!PropiedadHipotecada methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:11'!
elJugador: unJugador pagaPor: unaPropiedad 

|precio|

precio := (unaPropiedad precioDeCompra)*1.5.
unJugador pagaA: (unaPropiedad duenio) elMontoDe: precio.

unaPropiedad levatarHipoteca.! !

Object subclass: #PropiedadNoHipotecada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!PropiedadNoHipotecada methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:11'!
elJugador: unJugador pagaPor: unaPropiedad 

unJugador pagaA: (unaPropiedad duenio) elMontoDe: (unaPropiedad precioDeCompra).! !

Object subclass: #Provincia
	instanceVariableNames: 'campos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 21:37'!
agregarCampo: unCampo
campos add: unCampo.
unCampo perteneceAProvincia: self.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:42'!
agregarEstanciaEn: unCampo

((self sosMonopolio) & (self cumpleConstruccionPareja: unCampo)) ifFalse: [self error: 'No se puede contruir una estancia en el campo.'] 
ifTrue: [(unCampo duenio) paga: (unCampo costoDeEstancia).
unCampo sumarEstancia.]! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/11/2012 01:46'!
campos
^campos.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 01:03'!
cumpleConstruccionPareja: unCampo

| cantidadMinimaDeEstancias |

cantidadMinimaDeEstancias := ((self estancias) asSortedCollection: [:anterior :siguiente | anterior < siguiente]) first.

^(cantidadMinimaDeEstancias = unCampo cantidadDeEstancias)! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:01'!
duenios
^(campos collect: [:campo|campo duenio]).! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/12/2012 23:36'!
estancias
^(campos collect: [:campo|campo cantidadDeEstancias]).! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/11/2012 01:43'!
initialize 
campos := Set new.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 01:02'!
sosMonopolio
^((self duenios) size = 1)! !

Object subclass: #Tablero
	instanceVariableNames: 'casilleros'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'Estanciero'!

!Tablero class methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:38'!
instance
Instance ifNil: [ Instance := self new ].
^Instance.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:43'!
agregarCasillero: unCasillero

casilleros add: unCasillero.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:11'!
casilleros
^casilleros! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/13/2012 03:54'!
casillerosDesde: casilleroInicial hasta: unNumero
| misCasilleros recorrido |
misCasilleros := self casilleros copyAfter: casilleroInicial.
recorrido := OrderedCollection new.
[ recorrido size >= unNumero ] whileFalse: [
misCasilleros ifEmpty: [
misCasilleros addAll: self casilleros.
].
recorrido add: misCasilleros removeFirst. ].
^recorrido.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:13'!
casillerosEmpresa
^ self casilleros select: [ :unElem | unElem sosEmpresa ]! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'palbo 10/12/2012 15:27'!
dueniosEmpresas
^( self casillerosEmpresa collect: [:unElem | unElem duenio]).! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 00:42'!
initialize
casilleros := OrderedCollection new.! !
